<!-- eslint-disable vue/no-multiple-template-root -->
<template>
    <div class="common-playful">
      <header-playful />
      <div class="flex common-playful">
        <lazy-theme-desktop-playful-components-leftside-drawer :is-full-iframe="isFullIframe"/>
        <div class="w-full h-[calc(100vh-76px)] overflow-auto left-container">
          <el-scrollbar class="layout-scrollbar">
            <div class="mx-4">
              <div class="mx-auto content-wrapper sport-full-w">
                <div class="min-h-[unset] mx-auto">
                  <div class="flex gap-2 py-4">
                    <button class="drawer-btn min-[1379px]:!hidden" @click="drawer = true">
                      <svg-icon svg-name="left-arrow-fill" class="w-6 h-6" />
                    </button>
                    <Teleport to="body">
                      <el-drawer
                        :show-close="false"
                        direction="ltr"
                        v-model="drawer"
                        title="Menu"
                        size="320px"
                        class="menu-drawer"
                        :destroy-on-close="true">
                        <template #header>
                          <div class="header-drawer">
                              <button class="drawer-close-btn flex justify-center items-center" @click="drawer = false">
                                  <svg-icon svg-name="left-arrow-fill" class="w-6 h-6" />
                              </button>
                          </div>
                        </template>
                        <lazy-theme-desktop-playful-components-leftside-drawer :is-drawer-opened="true"/>
                      </el-drawer>
                    </Teleport>
                    <div class="px-3 gap-2 flex items-center justify-end bg-background5 rounded-lg announcement-container w-[1200px]">
                     <div v-if="!announcement.IsHidden" class=" flex-1">
                        <utils-announcement
                          :announcement="announcement.Text"
                          />
                      </div>
                      <client-only v-if="isDesktop" class="flex items-center space-x-8 time-block">
                        <div class="border-l h-4 border-[#4D5080]" />
                        <div class="whitespace-nowrap h-10 flex-none text-center flex items-center justify-center text-[var(--text5)] pl-2">
                          <span>{{ datetimeDisplay }}</span>
                        </div>
                      </client-only>
                    </div>
                  </div>
                  <banner
                  v-if="bannerShouldDisplay"
                  :actived-tab="activedTab"
                  :banner-keys="bannerKeys"
                  height="460px"
                  class="mb-4 playful-banner"
                  />
                </div>
                <slot class="w-full mx-auto min-h-[70vh]" />
              </div>
            </div>
            <div class="playful-desktop-footer">
              <lazy-footer template="common" layout="desktop" />
            </div>
            <div class="playful-mobile-footer">
              <lazy-footer template="playful" layout="mobile" />
            </div>
          </el-scrollbar>
        </div>
      </div>
      <new-black-theme-agent-cooperation-dialog />
      <new-black-theme-register-dialog v-if="!register.IsHidden && !isRegister" />
      <new-black-theme-login-dialog />
      <new-black-theme-sidebar />
    </div>
  </template>

  <script setup lang="ts">
  import _ from "lodash";
import { IThemePropertiesFromApi } from "~~/models/companyThemePropertiesRespone";
import EnumThemePropertyKey from "~~/models/enums/enumThemePropertyKey";
import { store } from "@/store";
import { gameStore } from "~~/store/game";

const drawer = ref(false);
const route = useRoute();
const allPages: Array<string> = [
  "home",
  "sports",
  "virtualsports",
  "livecasino",
  "games",
  "keno",
  "cockfight",
  "lottery",
  "poker",
  "promotion",
];
const bannerKeys: Record<string, string> = {
  home: "lobby_banner_",
  virtualsports: "virtual_sport_banner_",
  livecasino: "live_casino_banner_",
  games: "game_banner_",
  poker: "poker_banner_",
  lottery: "lottery_banner_",
  cockfight: "cockfight_banner_",
  promotion: "promotion_banner_",
  sports: "sport_banner_",
};
const tabSelected = computed(() =>
  _.replace(_.replace(route.path.split("/")[1], "-", ""), "/", "")
);
const activedTab = computed(() =>
  tabSelected.value !== "" ? tabSelected.value : "Home"
);
const bannerShouldDisplay = computed(() =>
  _.includes(allPages, _.toLower(activedTab.value))
);
const themeProperties = computed(
  () => store.state.companyThemePropertiesFromApi.ThemeProperties
);
const announcement = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      EnumThemePropertyKey.announcement
    )
);
const { datetimeDisplay } = useDisplayLocalTime();
const isDesktop = useIsDesktop();
const isRegister = computed(() => useRoute().name === 'register');
const register = computed(() =>
  themePropertyHelper.getSingleThemeProperty(
    themeProperties.value,
    "register"
  )
);
const containerWidth = ref('1200px');
const PANDA_PROVIDER_ID = 1053;
const currentGame = computed(() => gameStore.state.games.find((game) => game.GameId === Number(route.params.id)));
const isFullIframe = computed(() => route.query.tab === "sports");
watch(() => route.fullPath, () => {
  drawer.value = false;
}, {deep: true});
watch(currentGame, (game) => {
  if (game && game.GameProviderId === PANDA_PROVIDER_ID && game.GameIdAtGameProvider === 1) {
    containerWidth.value = '100%';
  } else {
    containerWidth.value = '1200px';
  }
}, {
  deep: true,
  immediate: true,
});
</script>

<style lang="scss">
.menu-drawer {
  .el-drawer__header {
    padding: 0;
    margin-bottom: 0;

    .header-drawer {
      padding: 16px;
      padding-bottom: 0px;
      background: linear-gradient(0deg, rgba(0, 0, 0, 0.25) 0%, rgba(0, 0, 0, 0.25) 100%), var(--background5);
    }

    .drawer-close-btn {
      padding: 4px;
      gap: 8px;
      height: 40px;
      width: 40px;
      border-radius: 8px;
      background: linear-gradient(0deg, rgba(255, 255, 255, 0.05) 0%, rgba(255, 255, 255, 0.05) 100%), var(--background5);
    }

    .drawer-close-btn svg {
      fill: var(--text5, #fff);
      opacity: 0.5;
      transition: opacity 350ms ease;
    }
  }
}
.layout-scrollbar {
 & > .el-scrollbar__bar.is-vertical {
  z-index: 22;
 }
}
.playful-banner {
  .el-carousel__indicators.el-carousel__indicators--horizontal {
    .el-carousel__indicator.el-carousel__indicator--horizontal {
      .el-carousel__button {
        width: 14px;
        height: 7px;
        border-radius: 4px;
        opacity: 1;
        background: var(--text5, #fff);
      }
    }
    .el-carousel__indicator.el-carousel__indicator--horizontal.is-active {
      .el-carousel__button {
        background: var(--primary);
        opacity: 1;
        width: 40px;
      }
    }
  }
}
::-webkit-scrollbar {
  height: 5px;
  width: 5px;
}
::-webkit-scrollbar-track {
  box-shadow: inset 0 0 1px transparent;
}
::-webkit-scrollbar-thumb {
  background-color: #b4bccc;
}
::-webkit-scrollbar-thumb:hover {
  background: #b4bccc;
}
</style>
<style scoped>
  .content-wrapper {
    max-width: v-bind(containerWidth);
  }
[layout="playful"] :deep(.el-carousel__item) {
  border-radius: 10.256px;
}
</style>

<style lang="scss">
.common-playful {
  .d-common-footer {
    width: 100% !important;
    max-width: 1200px;
  }
  .menu-nav-links {
      font-size: 12px;
    .uc-menu-tile {
      font-size: 12px;
    }
    .expand-language {
      .langauge-label {
        font-size: 12px;
      }
    }
  }
  .drawer-btn {
    display: flex;
      padding: 4px;
      align-items: center;
      justify-content: center;
      gap: 8px;
      height: 40px;
      width: 40px;
      border-radius: 8px;
      /* position: fixed; */
      rotate: 180deg;
      background: linear-gradient(0deg, rgba(255, 255, 255, 0.05) 0%, rgba(255, 255, 255, 0.05) 100%), var(--background5);
      /* top: 86px; */
      z-index: 25;
      left: 16px;
  }
  .footer-container {
    width: unset;
    .container {
      width: unset;
    }
  }
  @media screen and (min-width: 961px) {
    .playful-mobile-footer {
      display: none;
    }
  }
  @media screen and (max-width: 960px) {
    .playful-desktop-footer {
      display: none;
    }
    .time-block {
      display: none;
    }
  }
  .blog-game {
    .game-card-container {
        width: 100%;
        .game-card-image {
          height: unset;
        }
        .el-tooltip__trigger {
          width: 100%;
          height: unset;
        }
      }
    @media screen and (min-width: 150px) {
      grid-template-columns: repeat(3, minmax(0, 1fr));
      gap: 8px;
    }
    @media screen and (max-width: 360px) {
      grid-template-columns: repeat(3, minmax(0, 1fr));
      gap: 8px;
    }
    @media screen and (min-width: 584px) {
      grid-template-columns: repeat(4, minmax(0, 1fr));
      gap: 8px;
    }
    @media screen and (min-width: 732px) {
      grid-template-columns: repeat(5, minmax(0, 1fr));
      gap: 24px;
    }
    @media screen and (min-width: 960px) {
      grid-template-columns: repeat(6, minmax(0 ,1fr));
      gap: 24px;
    }
  }
}
</style>
